---
title: WEBGL_multi_draw
slug: Web/API/WEBGL_multi_draw
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_multi_draw</strong></code> extension is part of the
<a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and allows to render more
than one primitive with a single function call. This can improve a WebGL application's performance
as it reduces binding costs in the renderer and speeds up GPU thread time with uniform data.</p>

<p>When this extension is enabled:</p>
<ul>
  <li>New methods that handle multiple lists of arguments in one call are added 
    (see method list below).</li>
  <li>The <code>gl_DrawID</code> built-in is added to the shading language.</li>
</ul>

<div class="note">
  <p><strong>Availability:</strong> This extension is available to both, 
  {{domxref("WebGLRenderingContext", "WebGL 1", "", 1)}} and 
  {{domxref("WebGL2RenderingContext", "WebGL 2", "", 1)}} contexts.</p>
  <p>In shader code, the directive <code>#extension GL_ANGLE_multi_draw</code>
  needs to be called to enable the extension.</p>
  <p>This extension enables the {{domxref("ANGLE_instanced_arrays")}} extension implicitly.</p>
</div>

<h2 id="Methods">Methods</h2>

<dl>
 <dt><a href="/en-US/docs/Web/API/WEBGL_multi_draw/multiDrawArraysWEBGL"><code>ext.multiDrawArraysWEBGL()</code></a></dt>
 <dd>Renders multiple primitives from array data (identical to multiple calls to 
   <a href="/en-US/docs/Web/API/WebGLRenderingContext/drawArrays"><code>drawArrays</code></a>).</dd>
 <dt><a href="/en-US/docs/Web/API/WEBGL_multi_draw/multiDrawElementsWEBGL"><code>ext.multiDrawElementsWEBGL()</code></a></dt>
 <dd>Renders multiple primitives from element array data (identical to multiple calls to 
   <a href="en-US/docs/Web/API/WebGLRenderingContext/drawElements"><code>drawElements</code></a>).</dd>
 <dt><a href="/en-US/docs/Web/API/WEBGL_multi_draw/multiDrawArraysInstancedWEBGL"><code>ext.multiDrawArraysInstancedWEBGL()</code></a></dt>
 <dd>Renders multiple primitives from array data (identical to multiple calls to 
   <a href="/en-US/docs/Web/API/WebGL2RenderingContext/drawArraysInstanced"><code>drawArraysInstanced</code></a>).</dd>
 <dt><a href="/en-US/docs/Web/API/WEBGL_multi_draw/multiDrawElementsInstancedWEBGL"><code>ext.multiDrawElementsInstancedWEBGL()</code></a></dt>
 <dd>Renders multiple primitives from element array data (identical to multiple calls to 
   <a href="/en-US/docs/Web/API/WebGL2RenderingContext/drawElementsInstanced"><code>drawElementsInstanced</code></a>).</dd>
</dl>

<h2 id="Shader_extension">Shader extension</h2>

<p>Note: Although the extension name is named <code>WEBGL_multi_draw</code>, 
the extension must be enabled with the <code>#extension GL_ANGLE_multi_draw</code>
directive to use the extension in a shader.</p>

<p>When this extension is enabled, the <code>gl_DrawID</code> built-in can be used
in shader code. For any <code>multi*</code> draw call variant, 
the index of the draw <code>i</code> may be read by the vertex shader 
as <code>gl_DrawID</code>. For non-<code>multi*</code> calls, the value of 
<code>gl_DrawID</code> is <code>0</code>.</p>

<pre class="brush: html">&lt;script type="x-shader/x-vertex"&gt;
#extension GL_ANGLE_multi_draw : require
void main() {
  gl_Position = vec4(gl_DrawID, 0, 0, 1);
}
&lt;/script&gt;</pre>

<h2 id="Examples">Examples</h2>

<h3>Enabling the extension</h3>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. 
  For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a>
  in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<pre class="brush:js">
let ext = gl.getExtension('WEBGL_multi_draw');
</pre>

<h3>Drawing multiple arrays</h3>

<p>Example calls for <a href="/en-US/docs/Web/API/WEBGL_multi_draw/multiDrawArraysWEBGL"><code>ext.multiDrawArraysWEBGL()</code></a>
and <a href="/en-US/docs/Web/API/WEBGL_multi_draw/multiDrawArraysInstancedWEBGL"><code>ext.multiDrawArraysInstancedWEBGL()</code></a>:</p>

<pre class="brush:js">
// multiDrawArrays variant
// let firsts = new Int32Array(...);
// let counts = new Int32Array(...);
ext.multiDrawArraysWEBGL(gl.TRIANGLES, firsts, 0, counts, 0, firsts.length);

// multiDrawArraysInstanced variant
// let firsts = new Int32Array(...);
// let counts = new Int32Array(...);
// let instanceCounts = new Int32Array(...);
ext.multiDrawArraysInstancedWEBGL(
  gl.TRIANGLES, firsts, 0, counts, 0, instanceCounts, 0, firsts.length);
</pre>

<h3>Drawing multiple elements</h3>

<p>Example calls for <a href="/en-US/docs/Web/API/WEBGL_multi_draw/multiDrawElementsWEBGL"><code>ext.multiDrawElementsWEBGL()</code></a>
and <a href="/en-US/docs/Web/API/WEBGL_multi_draw/multiDrawElementsInstancedWEBGL"><code>ext.multiDrawElementsInstancedWEBGL()</code></a>.</p>
<p>Assumes that the indices which have been previously uploaded to the 
<code>ELEMENT_ARRAY_BUFFER</code> are to be treated as <code>UNSIGNED_SHORT</code>.</p>

<pre class="brush:js">
// multiDrawElements variant
// let counts = new Int32Array(...);
// let offsets = new Int32Array(...);
ext.multiDrawElementsWEBGL(
  gl.TRIANGLES, counts, 0, gl.UNSIGNED_SHORT, offsets, 0, counts.length);
}

// multiDrawElementsInstanced variant
// let counts = new Int32Array(...);
// let offsets = new Int32Array(...);
// let instanceCounts = new Int32Array(...);
ext.multiDrawElementsInstancedWEBGL(
    gl.TRIANGLES, counts, 0, gl.UNSIGNED_SHORT, offsets, 0, instanceCounts, 0,
    counts.length);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_multi_draw', "", "WEBGL_multi_draw")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. 
If you'd like to contribute to the data, please check out 
<a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a>
and send us a pull request.</p>

<p>{{Compat("WEBGL_multi_draw")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.drawArrays()")}}</li>
 <li>{{domxref("WebGLRenderingContext.drawElements()")}}</li>
 <li>{{domxref("ANGLE_instanced_arrays.drawArraysInstancedANGLE()")}} or 
     in WebGL 2: {{domxref("WebGL2RenderingContext.drawArraysInstanced()")}}</li>
 <li>{{domxref("ANGLE_instanced_arrays.drawElementsInstancedANGLE()")}} or
     in WebGL 2: {{domxref("WebGL2RenderingContext.drawElementsInstanced()")}}</li>
</ul>
